function clipboard_set(data) {
	var copyDiv = document.createElement('input');
    copyDiv.contentEditable = true;
    document.body.appendChild(copyDiv);
    copyDiv.value = data;
    copyDiv.unselectable = "off";
    copyDiv.focus();
    copyDiv.select();
    document.execCommand("copy");
    document.body.removeChild(copyDiv);
}

chrome.runtime.onMessage.addListener(function(message, sender, sendResponse){
    if (message.copy) {
        clipboard_set(message.copy);
    }
});

chrome.extension.onRequest.addListener(function(request, sender, sendResponse) {

    if (request.method == "getCookie") {
        chrome.cookies.get({ url: "http://app.vidiq.com", name: request.name }, function(cookie) {
            sendResponse(cookie);
        });
    } else if (request.method == "setCookie") {

        //set the cookie
        chrome.cookies.set({ url: "http://app.vidiq.com/", name: "_vidiq.sess", value: request.cookie, expirationDate: (new Date().getTime()/1000) + (3600 * 24 * 365) });

        sendResponse();

    } else if (request.method == "removeCookie") {

        chrome.cookies.getAll({domain: "app.vidiq.com"}, function(cookies) {
            for(var i=0; i<cookies.length;i++) {
                chrome.cookies.remove({url: "http://app.vidiq.com" + cookies[i].path, name: cookies[i].name});
            }
        });

        sendResponse();
    } else if (request.method == "removeTwitterCookies") {
        removeAllCookiesForDomain("mobile.twitter.com", function() {

            sendResponse();
            
        });

    }

});

function removeAllCookiesForDomain(domain, callback) {

    chrome.cookies.getAll({ 'domain': domain }, function(cookies) {

        // no cookies exist so return
        var len = cookies.length;
        if(!cookies || len == 0) {
            callback({});
            return;
        }

        var itemsLeftToFinish = len;
        for(var i = len - 1; i > -1; i--) {
            var cookie = cookies[i];
            // indicates url without protocol, we have to remove the period at the start of the url where it exists, and append the path
            var cookieUrl = (cookie.domain.substr(0,1)=='.' ? cookie.domain.substr(1) : cookie.domain) + cookie.path;
            // remove https cookie
            chrome.cookies.remove({ name: cookie.name, url: 'https://' + cookieUrl }, function() {
                // remove http cookie
                chrome.cookies.remove({ name: cookie.name, url: 'http://' + cookieUrl }, function() {
                    if(--itemsLeftToFinish == 0)
                        callback(cookies);
                });
            });
        }
    });

}
